# This file is a template, and might need editing before it works on your project.
# see https://docs.gitlab.com/ce/ci/yaml/README.html for all available options


#
# image
#
image: registry.gitlab.com/benjamin.boortz/docker-build-image:git-branch-name-as-docker-tag-name-2018-11-03-17-55-17



#
# variables
#
variables:
   DOCKER_HOST: tcp://docker:2375/
   DOCKER_DRIVER: overlay2



#
# services
#
services:
   - docker:dind



#
# stages
#
stages:
  - build
  - test
  - deploy



#
# before script execution
# 
before_script:
  - echo "Before script section"
  - apk update && apk upgrade
  - apk add --update git make
  - docker info



#
# after script execution
#
after_script:
  - echo "After script section"



#
# jobs
#
build:
  stage: build
  script:
    - echo "building ..."
    - make docker_build
    - make changelog_update

test:
  stage: test
  script: 
    - echo "testing ..."
    - make test

deploy:
  stage: deploy
  script:
    - echo "deployment ..."
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - make docker_push
